;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              #include <P16F628A.INC>
              LIST        p=16F628A     
              __CONFIG    H'3F18'           ; 
                                               
              errorlevel  -302              ;     302  

Sec           equ         0020h             ;  
Sec1          equ         0021h             ;
Sec2          equ         0022h             ;
nomer         equ         0023h             ;   ascii 
scetbit       equ         0024h             ;  -   
perem         equ         0025h             ;  /   spi, i2c                
temp          equ         0026h             ;  
tmp_symb      equ         0027h             ;      
oss           equ         0028h             ;      
tmp_tab   equ  0029h

DIGIT1        equ         0030h             ;     
DIGIT2        equ         0031h             ;   
DIGIT3        equ         0032h
DIGIT4        equ         0033h
DIGIT5        equ         0034h          
DIGIT6        equ         0035h
DIGIT7        equ         0036h
DIGIT8        equ         0037h
DIGIT9        equ         0038h
DIGIT10       equ         0039h
count_1       equ         003Ah
count_2       equ         003Bh
bin_HH        equ         003Ch
bin_HL        equ         003Dh
bin_LH        equ         003Eh
bin_LL        equ         003Fh


adr_i2c       equ         0040h             ;     i2c
tmp_i2c       equ         0041h
slave_adr     equ         0042h
data_i2c      equ         0043h

AC1_LH        equ         00A0h             ;     BMP180
AC1_LL        equ         00A1h
AC2_LH        equ         00A2h
AC2_LL        equ         00A3h
AC3_LH        equ         00A4h
AC3_LL        equ         00A5h
AC4_LH        equ         00A6h
AC4_LL        equ         00A7h
AC5_LH        equ         00A8h
AC5_LL        equ         00A9h
AC6_LH        equ         00AAh
AC6_LL        equ         00ABh
B1_LH         equ         00ACh
B1_LL         equ         00ADh
B2_LH         equ         00AEh
B2_LL         equ         00AFh
MB_LH         equ         00B0h
MB_LL         equ         00B1h
MC_LH         equ         00B2h
MC_LL         equ         00B3h
MD_LH         equ         00B4h
MD_LL         equ         00B5h

X1_HH         equ         00B6h             ;        BMP180
X1_HL         equ         00B7h
X1_LH         equ         00B8h
X1_LL         equ         00B9h
X2_HH         equ         00BAh
X2_HL         equ         00BBh
X2_LH         equ         00BCh
X2_LL         equ         00BDh
X3_HH         equ         00BEh
X3_HL         equ         00BFh
X3_LH         equ         00C0h
X3_LL         equ         00C1h
B3_HH         equ         00C2h
B3_HL         equ         00C3h
B3_LH         equ         00C4h
B3_LL         equ         00C5h
B5_HH         equ         00C6h
B5_HL         equ         00C7h
B5_LH         equ         00C8h
B5_LL         equ         00C9h
B4_HH         equ         00CAh
B4_HL         equ         00CBh
B4_LH         equ         00CCh
B4_LL         equ         00CDh
B6_HH         equ         00CEh
B6_HL         equ         00CFh
B6_LH         equ         00D0h
B6_LL         equ         00D1h

REGA3         equ         00D2h
REGA2         equ         00D3h
REGA1         equ         00D4h
REGA0         equ         00D5h
REGB3         equ         00D6h
REGB2         equ         00D7h
REGB1         equ         00D8h
REGB0         equ         00D9h
REGC3         equ         00DAh
REGC2         equ         00DBh
REGC1         equ         00DCh
REGC0         equ         00DDh
MTEMP         equ         00DEh
MCOUNT        equ         00DFh

P_HH          equ         00E0h             ;   
P_HL          equ         00E1h
P_LH          equ         00E2h
P_LL          equ         00E3h

P_M           equ         00E4h             ;      ..
P_L           equ         00E5h

T_HH          equ         00E6h             ;   
T_HL          equ         00E7h
T_LH          equ         00E8h
T_LL          equ         00E9h
 
tmp           equ         00EAh             ;  
y_adr     equ     00EBh;
x_adr      equ     00ECh;
flag          equ         007Fh             ; 
              
#DEFINE       res_lcd     PORTB,4           ;   -
#DEFINE       cs          PORTB,5           ;   LCD  Nokia 5110
#DEFINE       dat_com     PORTB,6           ;
#DEFINE       sdata       PORTB,7           ;
#DEFINE       sclk        PORTA,1           ;

#DEFINE       sda         PORTB,2           ; SDA    BMP180
#DEFINE       scl         PORTB,3           ; SCL    BMP180
#DEFINE       sda_io      TRISB,2           ;  SDA 
#DEFINE       scl_io      TRISB,3           ;  SCL 
#DEFINE       led         PORTA,0           ;  i2c

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                             
Start         movlw       b'00000010'       ;     A     
              movwf       PORTA             ;
              movlw       b'00110000'       ;     B     
              movwf       PORTB             ; 
              
              movlw       b'00000111'       ; 
              movwf       CMCON             ;

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00001111'       ;  \  B      
              movwf       TRISB             ;RB0,RB1 -  ,   
 
              movlw       b'11111100'       ;  \  A   
              movwf       TRISA             ;RA0,RA1 -  ,                         
              bcf         STATUS,RP0        ; 0-  
                     
              clrf        flag              ;   
              clrf  x_adr
              clrf  y_adr
                           
              call        init_lcd          ;   
              call        clear_lcd         ;   
              call        viv_not           ;    "--- "
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
              
              movlw       b'11101110'       ; (BMP180)
              movwf       slave_adr

              call        paus              ;   5,3 
              movlw       .22               ;    (22 )  2-  
              movwf       tmp_i2c           ;
              movlw       0xAA              ;      
              movwf       adr_i2c           ;
              bsf         flag,3            ;     
              call        read_i2c          ;    I2C
              call        err_prov          ;   / I2C
     
bmp_1         call        rd_temp           ;      BMP180

              movlw       data_i2c          ;    T
              movwf       FSR 
              bsf         STATUS,RP0   
              movf        INDF,W                       
              movwf       T_LH
              incf        FSR,F 
              movf        INDF,W
              movwf       T_LL
              bcf         STATUS,RP0          

              movlw       .0                ;    (16-19, 0-3(oss))
              movwf       oss
              call        rd_pres           ;      BMP180

              movlw       data_i2c          ;    P
              movwf       FSR  
              bsf         STATUS,RP0  
              movf        INDF,W
              movwf       P_HL
              incf        FSR,F 
              movf        INDF,W
              movwf       P_LH
              incf        FSR,F 
              movf        INDF,W
              movwf       P_LL
              clrf        P_HH
              bcf         STATUS,RP0
              movf        oss,W             ;     P
              sublw       .8                ;    
              bsf         STATUS,RP0
              movwf       tmp
bmp_2         bcf         STATUS,C
              rrf         P_HH,F
              rrf         P_HL,F
              rrf         P_LH,F
              rrf         P_LL,F
              decfsz      tmp,F
              goto        bmp_2
    
              call        rash_T_P          ;      
           
              
              bsf         STATUS,RP0        ;     bin
              movf        T_HH,W
              bcf         STATUS,RP0
              movwf       bin_HH
              bsf         STATUS,RP0
              movf        T_HL,W
              bcf         STATUS,RP0
              movwf       bin_HL
              bsf         STATUS,RP0
              movf        T_LH,W
              bcf         STATUS,RP0
              movwf       bin_LH
              bsf         STATUS,RP0
              movf        T_LL,W
              bcf         STATUS,RP0
              movwf       bin_LL
                          
              call        bin2dec           ;      
              call        ust_cur_1         ;   1-  LCD 
              call        vivod_temp        ;    LCD

             

              bsf         STATUS,RP0        ;     bin
              movf        P_HH,W
              bcf         STATUS,RP0
              movwf       bin_HH
              bsf         STATUS,RP0
              movf        P_HL,W
              bcf         STATUS,RP0
              movwf       bin_HL
              bsf         STATUS,RP0
              movf        P_LH,W
              bcf         STATUS,RP0
              movwf       bin_LH
              bsf         STATUS,RP0
              movf        P_LL,W
              bcf         STATUS,RP0
              movwf       bin_LL

              call        bin2dec           ;      
              call        ust_cur_5         ;   3-  LCD 
              call        vivod_p           ;   ()  LCD

              bsf         STATUS,RP0
              movf        P_M,W             ;   ( . )   bin 
              bcf         STATUS,RP0
              movwf       bin_LH
              bsf         STATUS,RP0
              movf        P_L,W
              bcf         STATUS,RP0
              movwf       bin_LL
              clrf        bin_HL
              clrf        bin_HH

              call        bin2dec           ;      
              call        ust_cur_3         ;   2-  LCD 
              call        viv_p_mm          ;   ( ..)  LCD 

              call        paus1s            ; 1 
         
              goto        bmp_1             ;   bmp_1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       BMP180   I2C
            
rd_temp       movlw       0x2E              ;    
              movwf       data_i2c           
              goto        rd_bmp1
             
rd_pres       movlw       0x34              ;       
              movwf       data_i2c          ;   
              movf        oss,W
              movwf       perem
              incf        perem,F
pres_2        decfsz      perem,F
              goto        pres_1
              goto        rd_bmp1

pres_1        movlw       0x40
              addwf       data_i2c,F
              goto        pres_2

rd_bmp1       movlw       .1                ;     I2C
              movwf       tmp_i2c           ;    I2C
              movlw       0xF4              ;
              movwf       adr_i2c           ;      
              call        write_i2c         ;    I2C
              call        err_prov          ;   / I2C
 
rd_bmp2       call        paus              ;   5,3 

              movlw       .1                ;  
              movwf       tmp_i2c           ;    I2C
              movlw       0xF4              ;
              movwf       adr_i2c           ;      
              call        read_i2c          ;    I2C
              call        err_prov          ;   / I2C

              movlw      data_i2c
              movwf      FSR 

              btfsc      INDF,5             ;   
              goto       rd_bmp2            ;  :    rd_bmp2

              movlw       .3                ;  
              movwf       tmp_i2c           ; 3-   I2C
              movlw       0xF6              ;
              movwf       adr_i2c           ;      
              call        read_i2c          ;    I2C
              call        err_prov          ;   / I2C
              return                        ;  

err_prov      btfss       flag,6            ;    I2C
              return                        ; :    
err_1         bsf         led               ;:   led
              goto        err_1             ;   err_1:  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rash_T_P      bsf         STATUS,RP0        ;  2- 

              clrf        REGA3             ;   UT  REGA
              clrf        REGA2
              movf        T_LH,W
              movwf       REGA1
              movf        T_LL,W
              movwf       REGA0

              clrf        REGB3             ;   AC6  REGB
              clrf        REGB2
              movf        AC6_LH,W
              movwf       REGB1
              movf        AC6_LL,W
              movwf       REGB0

              call        subtract          ; UT-AC6

              clrf        REGB3             ;   AC5  REGB
              clrf        REGB2
              movf        AC5_LH,W
              movwf       REGB1
              movf        AC5_LL,W
              movwf       REGB0

              call        multiply          ; (UT-AC6)*AC5

              movlw       .15               ; [(UT-AC6)*AC5]/2^15 = X1
              movwf       tmp
tdel_a1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        tdel_a1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              btfsc       MD_LH,7           ;   MD  REGB
              goto        tzag_a1
              clrf        REGB3
              clrf        REGB2
              goto        tzag_a2
tzag_a1       movlw       .255
              movwf       REGB3
              movlw       .255
              movwf       REGB2
tzag_a2       movf        MD_LH,W
              movwf       REGB1
              movf        MD_LL,W
              movwf       REGB0

              call        add               ; X1+MD

              movf        REGA0,W           ;  (X1+MD)  REGB
              movwf       REGB0            
              movf        REGA1,W         
              movwf       REGB1
              movf        REGA2,W         
              movwf       REGB2
              movf        REGA3,W         
              movwf       REGB3  
 
              btfsc       MC_LH,7           ;   MC
              goto        tzag_b1
              clrf        REGA3
              clrf        REGA2
              goto        tzag_b2
tzag_b1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
tzag_b2       movf        MC_LH,W
              movwf       REGA1
              movf        MC_LL,W
              movwf       REGA0
              
              movlw       .11               ; MC * 2^11
              movwf       tmp
tumn_a1       bcf         STATUS,C
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
              decfsz      tmp,F
              goto        tumn_a1

              call        divide            ; (MC * 2^11)/(X1+MD) = X2

              movf        X1_HH,W           ;  X1  REGB
              movwf       REGB3
              movf        X1_HL,W
              movwf       REGB2
              movf        X1_LH,W
              movwf       REGB1
              movf        X1_LL,W
              movwf       REGB0

              call        add               ; X1 + X2 = B5

              movf        REGA3,W           ;    B5
              movwf       B5_HH
              movf        REGA2,W
              movwf       B5_HL
              movf        REGA1,W
              movwf       B5_LH
              movf        REGA0,W
              movwf       B5_LL

              movlw       .8                ;  8  REGB
              movwf       REGB0
              clrf        REGB1
              clrf        REGB2
              clrf        REGB3

              call        add               ; B5 + 8

              movlw       .4                ; (B5 + 8)/2^4
              movwf       tmp
tdel_b1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        tdel_b1

              movf        REGA0,W           ;     T
              movwf       T_LL
              movf        REGA1,W
              movwf       T_LH
              movf        REGA2,W
              movwf       T_HL
              movf        REGA3,W
              movwf       T_HH

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rash_P        movf        B5_HH,W           ;  B5  REGA
              movwf       REGA3
              movf        B5_HL,W
              movwf       REGA2
              movf        B5_LH,W
              movwf       REGA1
              movf        B5_LL,W
              movwf       REGA0

                            
              clrf        REGB3             ;  4000  REGB
              clrf        REGB2
              movlw       0x0F
              movwf       REGB1
              movlw       0xA0
              movwf       REGB0

              call        subtract          ; B5 - 4000 = B6

              movf        REGA3,W           ;    B6  REGB
              movwf       B6_HH
              movwf       REGB3
              movf        REGA2,W
              movwf       B6_HL
              movwf       REGB2
              movf        REGA1,W
              movwf       B6_LH
              movwf       REGB1
              movf        REGA0,W
              movwf       B6_LL
              movwf       REGB0

              call        multiply          ; B6 * B6

              movlw       .12               ; (B6 * B6)/2^12
              movwf       tmp
pdel_a1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_a1

              movf        REGA3,W           ;  ((B6 * B6)/2^12)   X2
              movwf       X2_HH             ;  ,   X2   
              movf        REGA2,W
              movwf       X2_HL
              movf        REGA1,W
              movwf       X2_LH
              movf        REGA0,W
              movwf       X2_LL

              btfsc       B2_LH,7           ;   B2  REGB
              goto        pzag_a1
              clrf        REGB3
              clrf        REGB2
              goto        pzag_a2
pzag_a1       movlw       .255
              movwf       REGB3
              movlw       .255
              movwf       REGB2
pzag_a2       movf        B2_LH,W
              movwf       REGB1
              movf        B2_LL,W
              movwf       REGB0

              call        multiply          ; B2 * [(B6 * B6)/2^12]

              movlw       .11               ; (B2 * [(B6 * B6)/2^12])/2^11
              movwf       tmp
pdel_b1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_b1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              btfsc       AC2_LH,7          ;   AC2  REGA
              goto        pzag_b1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_b2
pzag_b1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_b2       movf        AC2_LH,W
              movwf       REGA1
              movf        AC2_LL,W
              movwf       REGA0

              movf        B6_LL,W           ;  B6  REGB
              movwf       REGB0            
              movf        B6_LH,W         
              movwf       REGB1
              movf        B6_HL,W         
              movwf       REGB2
              movf        B6_HH,W         
              movwf       REGB3  

              call        multiply          ; AC2 * B6

              movlw       .11               ; (AC2 * B6)/2^11 = X2
              movwf       tmp
pdel_c1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_c1

              movf        X1_LL,W           ;  X1  REGB
              movwf       REGB0            
              movf        X1_LH,W         
              movwf       REGB1
              movf        X1_HL,W         
              movwf       REGB2
              movf        X1_HH,W         
              movwf       REGB3  

              call        add               ; X1 + X2 = X3

              movf        REGA3,W           ;    X3
              movwf       X3_HH
              movf        REGA2,W
              movwf       X3_HL
              movf        REGA1,W
              movwf       X3_LH
              movf        REGA0,W
              movwf       X3_LL

              btfsc       AC1_LH,7          ;   AC1  REGA
              goto        pzag_c1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_c2
pzag_c1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_c2       movf        AC1_LH,W
              movwf       REGA1
              movf        AC1_LL,W
              movwf       REGA0

              movlw       .2                ; AC1 * 4
              movwf       tmp
pumn_a1       bcf         STATUS,C
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
              decfsz      tmp,F
              goto        pumn_a1

              movf        X3_LL,W           ;  X3  REGB
              movwf       REGB0            
              movf        X3_LH,W         
              movwf       REGB1
              movf        X3_HL,W         
              movwf       REGB2
              movf        X3_HH,W         
              movwf       REGB3  

              call        add               ; (AC1 * 4) + X3

              bcf         STATUS,RP0
              movf        oss,W             ; ((AC1 * 4) + X3)<<oss
              xorlw       .0
              bsf         STATUS,RP0
              btfsc       STATUS,Z
              goto        pumn_c1
              bcf         STATUS,RP0
              movf        oss,W 
              bsf         STATUS,RP0              
              movwf       tmp
pumn_b1       bcf         STATUS,C
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
              decfsz      tmp,F
              goto        pumn_b1

pumn_c1       movlw       .2                ;  2  REGB
              movwf       REGB0
              clrf        REGB1
              clrf        REGB2
              clrf        REGB3

              call        add               ; [((AC1 * 4) + X3)<<oss] + 2

              movlw       .2                ; ([((AC1 * 4) + X3)<<oss] + 2)/4
              movwf       tmp
pdel_d1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_d1
 
              movf        REGA3,W           ;    B3
              movwf       B3_HH
              movf        REGA2,W
              movwf       B3_HL
              movf        REGA1,W
              movwf       B3_LH
              movf        REGA0,W
              movwf       B3_LL

              btfsc       AC3_LH,7          ;   AC3  REGA
              goto        pzag_d1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_d2
pzag_d1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_d2       movf        AC3_LH,W
              movwf       REGA1
              movf        AC3_LL,W
              movwf       REGA0

              movf        B6_LL,W           ;  B6  REGB
              movwf       REGB0            
              movf        B6_LH,W         
              movwf       REGB1
              movf        B6_HL,W         
              movwf       REGB2
              movf        B6_HH,W         
              movwf       REGB3  

              call        multiply          ; AC3 * B6

              movlw       .13               ; (AC3 * B6)/2^13 = X1
              movwf       tmp
pdel_e1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_e1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              btfsc       B1_LH,7           ;   B1  REGA
              goto        pzag_e1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_e2
pzag_e1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_e2       movf        B1_LH,W
              movwf       REGA1
              movf        B1_LL,W
              movwf       REGA0

              movf        X2_LL,W           ;  (B6 * B6)/2^12  X2  REGB
              movwf       REGB0            
              movf        X2_LH,W         
              movwf       REGB1
              movf        X2_HL,W         
              movwf       REGB2
              movf        X2_HH,W         
              movwf       REGB3  

              call        multiply          ; B1 * ((B6 * B6)/2^12)

              movlw       .16               ; (B1 * ((B6 * B6)/2^12))/2^16 = X2
              movwf       tmp
pdel_f1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_f1

              movf        X1_LL,W           ;  X1  REGB
              movwf       REGB0            
              movf        X1_LH,W         
              movwf       REGB1
              movf        X1_HL,W         
              movwf       REGB2
              movf        X1_HH,W         
              movwf       REGB3  

              call        add               ; X1 + X2

              movlw       .2                ;  2  REGB
              movwf       REGB0
              clrf        REGB1
              clrf        REGB2
              clrf        REGB3

              call        add               ; (X1 + X2) + 2

              movlw       .2                ; ((X1 + X2) + 2)/4 = X3
              movwf       tmp
pdel_g1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_g1                     
               
              clrf        REGB3             ;  32768  REGB
              clrf        REGB2
              movlw       0x80
              movwf       REGB1
              clrf        REGB0

              call        add               ; X3 + 32768 

              clrf        REGB3             ;   AC4  REGB
              clrf        REGB2
              movf        AC4_LH,W
              movwf       REGB1
              movf        AC4_LL,W
              movwf       REGB0

              call        multiply          ; AC4 * (X3 + 32768)

              movlw       .15               ; (AC4 * (X3 + 32768)/2^15) = B4
              movwf       tmp
pdel_h1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_h1

              movf        REGA3,W           ;    B4
              movwf       B4_HH
              movf        REGA2,W
              movwf       B4_HL
              movf        REGA1,W
              movwf       B4_LH
              movf        REGA0,W
              movwf       B4_LL

              movf        P_HH,W            ;  UP  REGA
              movwf       REGA3
              movf        P_HL,W
              movwf       REGA2
              movf        P_LH,W
              movwf       REGA1
              movf        P_LL,W
              movwf       REGA0

              movf        B3_LL,W           ;  B3  REGB
              movwf       REGB0            
              movf        B3_LH,W         
              movwf       REGB1
              movf        B3_HL,W         
              movwf       REGB2
              movf        B3_HH,W         
              movwf       REGB3  

              call        subtract          ; UP-B3
                
              clrf        REGB3             ;  50000  REGB
              clrf        REGB2
              movlw       0xC3
              movwf       REGB1
              movlw       0x50
              movwf       REGB0

              bcf         STATUS,RP0
              movf        oss,W             ; 50000 >> oss
              xorlw       .0
              bsf         STATUS,RP0
              btfsc       STATUS,Z
              goto        pdel_k1
              bcf         STATUS,RP0
              movf        oss,W 
              bsf         STATUS,RP0              
              movwf       tmp
pdel_j1       rlf         REGB3,W
              rrf         REGB3,F
              rrf         REGB2,F
              rrf         REGB1,F
              rrf         REGB0,F
              decfsz      tmp,F
              goto        pdel_j1

pdel_k1       call        multiply          ; (UP-B3) * (50000 >> oss)

              btfsc       REGA3,7
              goto        rash_P1

              bcf         STATUS,C          ;B7 < 0x80000000  (B7 * 2)
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
            
              movf        B4_LL,W           ;  B4  REGB
              movwf       REGB0           
              movf        B4_LH,W         
              movwf       REGB1
              movf        B4_HL,W         
              movwf       REGB2
              movf        B4_HH,W         
              movwf       REGB3  
              
              call        divide_uns        ;  (B7 * 2)/B4
              goto        rash_P2

rash_P1       movf        B4_LL,W           ;B7 >= 0x80000000,   B4  REGB
              movwf       REGB0            
              movf        B4_LH,W         
              movwf       REGB1
              movf        B4_HL,W         
              movwf       REGB2
              movf        B4_HH,W         
              movwf       REGB3  

              call        divide_uns        ;  B7/B4

              bcf         STATUS,C          ; (B7/B4) * 2
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
             

rash_P2       movf        REGA3,W           ;    P
              movwf       P_HH
              movf        REGA2,W
              movwf       P_HL
              movf        REGA1,W
              movwf       P_LH
              movf        REGA0,W
              movwf       P_LL

              movlw       .8                ; P/2^8
              movwf       tmp
pdel_l1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_l1

              movf        REGA3,W           ;   REGA  REGB
              movwf       REGB3
              movf        REGA2,W
              movwf       REGB2
              movf        REGA1,W
              movwf       REGB1
              movf        REGA0,W
              movwf       REGB0

              call        multiply          ; (P/2^8) * (P/2^8) = X1
             
              clrf        REGB3             ;  3038  REGB
              clrf        REGB2
              movlw       0x0B
              movwf       REGB1
              movlw       0xDE
              movwf       REGB0

              call        multiply          ; X1 * 3038

              movlw       .16               ; (X1 * 3038)/2^16 = X1
              movwf       tmp
pdel_o1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_o1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              movlw       0xFF              ;  -7357  REGA
              movwf       REGA3           
              movlw       0xFF
              movwf       REGA2
              movlw       0xE3
              movwf       REGA1
              movlw       0x43
              movwf       REGA0
    
              movf        P_LL,W            ;  P  REGB
              movwf       REGB0           
              movf        P_LH,W         
              movwf       REGB1
              movf        P_HL,W         
              movwf       REGB2
              movf        P_HH,W         
              movwf       REGB3  

              call        multiply          ; (-7357) * P

              movlw       .16               ; ((-7357) * P)/2^16 = X2
              movwf       tmp
pdel_p1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_p1

              movf        X1_LL,W           ;  X1  REGB
              movwf       REGB0            
              movf        X1_LH,W         
              movwf       REGB1
              movf        X1_HL,W         
              movwf       REGB2
              movf        X1_HH,W         
              movwf       REGB3  
 
              call        add               ; (X1 + X2)

              clrf        REGB3             ;  3791  REGB
              clrf        REGB2
              movlw       0x0E
              movwf       REGB1
              movlw       0xCF
              movwf       REGB0

              call        add               ; (X1 + X2)+3791

              movlw       .4                ; ((X1 + X2)+3791)/2^4
              movwf       tmp
pdel_q1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_q1

              movf        P_LL,W            ;  P  REGB
              movwf       REGB0            
              movf        P_LH,W         
              movwf       REGB1
              movf        P_HL,W       
              movwf       REGB2
              movf        P_HH,W         
              movwf       REGB3  

              call        add               ; P + ((X1 + X2)+3791)/2^4 = P

              movf        REGA3,W           ;    P
              movwf       P_HH
              movf        REGA2,W
              movwf       P_HL
              movf        REGA1,W
              movwf       P_LH
              movf        REGA0,W
              movwf       P_LL

              clrf        REGB3             ;  133  REGB
              clrf        REGB2
              clrf        REGB1
              movlw       0x85
              movwf       REGB0

              call        divide            ; P/133    ..

              movf        REGA1,W           ;    P_M, P_L
              movwf       P_M
              movf        REGA0,W
              movwf       P_L
 
              bcf         STATUS,RP0
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;*** 32 BIT SIGNED SUTRACT ***
;REGA - REGB -> REGA
;Return carry set if overflow

subtract
              call        negateb		;Negate REGB
              skpnc
	          return			;Overflow

;*** 32 BIT SIGNED ADD ***
;REGA + REGB -> REGA
;Return carry set if overflow

add	movf	REGA3,w		;Compare signs
	xorwf	REGB3,w
	movwf	MTEMP

	call	addba		;Add REGB to REGA

	clrc			;Check signs
	movf	REGB3,w		;If signs are same
	xorwf	REGA3,w		;so must result sign
	btfss	MTEMP,7		;else overflow
	addlw	0x80
	return

;*** 32 BIT SIGNED MULTIPLY ***
;REGA * REGB -> REGA
;Return carry set if overflow

multiply
	clrf	MTEMP		;Reset sign flag
	call	absa		;Make REGA positive
	skpc
	call	absb		;Make REGB positive
	skpnc
	return			;Overflow

	call	movac		;Move REGA to REGC
	call	clra		;Clear product

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

muloop	call	slac		;Shift left product and multiplicand
	
	rlf	REGC3,w		;Test MSB of multiplicand
	skpnc			;If multiplicand bit is a 1 then
	call	addba		;add multiplier to product

	skpc			;Check for overflow
	rlf	REGA3,w
	skpnc
	return

	decfsz	MCOUNT,f	;Next
	goto	muloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return


;*** 32 BIT SIGNED DIVIDE ***
;REGA / REGB -> REGA
;Remainder in REGC
;Return carry set if overflow or division by zero

divide	clrf	MTEMP		;Reset sign flag
	movf	REGB0,w		;Trap division by zero
	iorwf	REGB1,w
	iorwf	REGB2,w
	iorwf	REGB3,w
	sublw	0
	skpc
	call	absa		;Make dividend (REGA) positive
	skpc
	call	absb		;Make divisor (REGB) positive
	skpnc
	return			;Overflow

dv_un	clrf	REGC0		;Clear remainder
	clrf	REGC1
	clrf	REGC2
	clrf	REGC3
	call	slac		;Purge sign bit

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

dvloop	call	slac		;Shift dividend (REGA) msb into remainder (REGC)

	movf	REGB3,w		;Test if remainder (REGC) >= divisor (REGB)
	subwf	REGC3,w
	skpz
	goto	dtstgt
	movf	REGB2,w
	subwf	REGC2,w
	skpz
	goto	dtstgt
	movf	REGB1,w
	subwf	REGC1,w
	skpz
	goto	dtstgt
	movf	REGB0,w
	subwf	REGC0,w
dtstgt	skpc			;Carry set if remainder >= divisor
	goto	dremlt

	movf	REGB0,w		;Subtract divisor (REGB) from remainder (REGC)
	subwf	REGC0,f
	movf	REGB1,w
	skpc
	incfsz	REGB1,w
	subwf	REGC1,f
	movf	REGB2,w
	skpc
	incfsz	REGB2,w
	subwf	REGC2,f
	movf	REGB3,w
	skpc
	incfsz	REGB3,w
	subwf	REGC3,f
	clrc
	bsf	REGA0,0		;Set quotient bit

dremlt	decfsz	MCOUNT,f	;Next
	goto	dvloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return

divide_uns   clrf	MTEMP		;Reset sign flag
	         movf	REGB0,w		;Trap division by zero
          	 iorwf	REGB1,w
	         iorwf	REGB2,w
   	         iorwf	REGB3,w
	         sublw	0
	         skpnc
	         return			;Overflow
             goto   dv_un


;Add REGB to REGA (Unsigned)
;Used by add, multiply,

addba	movf	REGB0,w		;Add lo byte
	addwf	REGA0,f

	movf	REGB1,w		;Add mid-lo byte
	skpnc			;No carry_in, so just add
	incfsz	REGB1,w		;Add carry_in to REGB
	addwf	REGA1,f		;Add and propagate carry_out

	movf	REGB2,w		;Add mid-hi byte
	skpnc
	incfsz	REGB2,w
	addwf	REGA2,f

	movf	REGB3,w		;Add hi byte
	skpnc
	incfsz	REGB3,w
	addwf	REGA3,f
	return


;Move REGA to REGC
;Used by multiply, sqrt

movac	movf	REGA0,w
	movwf	REGC0
	movf	REGA1,w
	movwf	REGC1
	movf	REGA2,w
	movwf	REGC2
	movf	REGA3,w
	movwf	REGC3
	return

;Clear REGA
;Used by multiply, sqrt

clra	clrf	REGA0
	clrf	REGA1
	clrf	REGA2
	clrf	REGA3
	return


;Check sign of REGA and convert negative to positive
;Used by multiply, divide, bin2dec, round

absa	rlf	REGA3,w
	skpc
	return			;Positive

;Negate REGA
;Used by absa, multiply, divide, bin2dec, dec2bin, round

negatea	movf	REGA3,w		;Save sign in w
	andlw	0x80

	comf	REGA0,f		;2's complement
	comf	REGA1,f
	comf	REGA2,f
	comf	REGA3,f
	incfsz	REGA0,f
	goto	nega1
	incfsz	REGA1,f
	goto	nega1
	incfsz	REGA2,f
	goto	nega1
	incf	REGA3,f
nega1
	incf	MTEMP,f		;flip sign flag
	addwf	REGA3,w		;Return carry set if -2147483648
	return


;Check sign of REGB and convert negative to positive
;Used by multiply, divide

absb	rlf	REGB3,w
	skpc
	return			;Positive

;Negate REGB
;Used by absb, subtract, multiply, divide

negateb	movf	REGB3,w		;Save sign in w
	andlw	0x80

	comf	REGB0,f		;2's complement
	comf	REGB1,f
	comf	REGB2,f
	comf	REGB3,f
	incfsz	REGB0,f
	goto	negb1
	incfsz	REGB1,f
	goto	negb1
	incfsz	REGB2,f
	goto	negb1
	incf	REGB3,f
negb1
	incf	MTEMP,f		;flip sign flag
	addwf	REGB3,w		;Return carry set if -2147483648
	return


;Shift left REGA and REGC
;Used by multiply, divide, round

slac	rlf	REGA0,f
	rlf	REGA1,f
	rlf	REGA2,f
	rlf	REGA3,f
slc	rlf	REGC0,f
	rlf	REGC1,f
	rlf	REGC2,f
	rlf	REGC3,f
	return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    LCD 

vivod_temp
            btfss       flag,7            ;  
              goto        viv_t1
              movlw       '-'
              call        viv_symb          ;     
              goto        viv_t2 
viv_t1        movlw       '+'
              call        viv_symb          ;     

viv_t2        movf        DIGIT8,W
              xorlw       .0
              btfsc       STATUS,Z
              goto        viv_t3

              movf        DIGIT8,W          ; 
              addlw       .48               ;
              call        viv_symb          ;     
              
viv_t3        movf        DIGIT9,W          ;  
              addlw       .48               ;
              call        viv_symb          ;     

              movlw       '.'
              call        viv_symb          ;     

              movf        DIGIT10,W         ;  
              addlw       .48               ;
              call        viv_symb          ;     

              movlw       0xF8
              call        viv_symb          ;     
 
              movlw       'O'
              call        viv_symb          ;     

              movlw       'C'
              call        viv_symb          ;     
             


              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   ()  LCD 

vivod_p       movf        DIGIT5,W
              xorlw       .0
              btfsc       STATUS,Z
              goto        vivd_p1

              movf        DIGIT5,W          ; 
              addlw       .48               ;
              call        viv_symb          ;     

vivd_p1       movf        DIGIT6,W          ;  
              addlw       .48               ;
              call        viv_symb          ;     

              movf        DIGIT7,W          ;  
              addlw       .48               ;
              call        viv_symb          ;     

              movf        DIGIT8,W          ;  
              addlw       .48               ;
              call        viv_symb          ;     
 
              movf        DIGIT9,W          ; 
              addlw       .48               ;
              call        viv_symb          ;     

             ; movf        DIGIT10,W         ;  
              ;addlw       .48               ;
              movlw  'D'
              call        viv_symb          ;     

              movlw       'E'
              call        viv_symb          ;     
 
              movlw       'F'
              call        viv_symb          ;     

             ; movlw       ''
             ; call        viv_symb          ;     

             ; movlw       ' '
             ; call        viv_symb          ;     
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   ( . .)  LCD 

viv_p_mm      movf        DIGIT8,W          ;  
              addlw       .48               ;
              call        viv_symb          ;     
 
              movf        DIGIT9,W          ;  
              addlw       .48               ;
              call        viv_symb          ;     

              movf        DIGIT10,W         ; 
              addlw       .48               ;
              call        viv_symb          ;     

              movlw       'P'
              call        viv_symb          ;     

              movlw       'Q'
              call        viv_symb          ;     

              movlw       'R'
              call        viv_symb          ;     

              movlw       'S'
              call        viv_symb          ;     

              movlw       'T'
              call        viv_symb          ;     

              ;movlw       ''
              ;call        viv_symb          ;     

              ;movlw       '.'
              ;call        viv_symb          ;     

              ;movlw       ''
              ;call        viv_symb          ;     

              ;movlw       ''
              ;call        viv_symb          ;     

              ;movlw       '.'
              ;call        viv_symb          ;     
              return


;        
; 32-      bin_HH, bin_HL, bin_LH, bin_LL
;      DIGIT1,    DIGIT10

bin2dec       bcf         flag,7            ;  
              btfss       bin_HH,7          ;   
              goto        bin2dec_1
              comf        bin_HH,F          ;   bin  
              comf        bin_HL,F          ;  
              comf        bin_LH,F
              comf        bin_LL,F
              incfsz      bin_LL,F
              goto        bin2dec_2
              incfsz      bin_LH,F
              goto        bin2dec_2
              incfsz      bin_HL,F
              goto        bin2dec_2
              incf        bin_HH,F
bin2dec_2     bsf         flag,7            ;  . 

bin2dec_1     clrf        DIGIT1            ;   . 
              clrf        DIGIT2
              clrf        DIGIT3
              clrf        DIGIT4
              clrf        DIGIT5
              clrf        DIGIT6
              clrf        DIGIT7
              clrf        DIGIT8
              clrf        DIGIT9
              clrf        DIGIT10            

              movlw       .32	             ;Loop counter
              movwf       count_1

b2dloop       rlf         bin_LL,F           ;Shift msb into carry
              rlf         bin_LH,F
              rlf         bin_HL,F
              rlf         bin_HH,F
    
              movlw       DIGIT10
              movwf       FSR                ;Pointer to digits
              movlw       .10                ;10 digits to do
              movwf       count_2

adjlp         rlf         INDF,F             ;Shift digit and carry 1 bit left
              movlw       .10
              subwf       INDF,W             ;Check and adjust for decimal overflow
              skpnc
              movwf       INDF

              decf        FSR,F	             ;Next digit
              decfsz      count_2,F
              goto        adjlp

              decfsz      count_1,F          ;Next bit
              goto        b2dloop
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; /   I2C

write_i2c     bsf         flag,4            ;  
              goto        i2c_1             ;   i2c_1
read_i2c      bcf         flag,4            ;  ( )
              bcf         flag,5            ;   
i2c_1         bcf         flag,6            ;   I2C
              call        starti2c          ;  ""  I2C
            
              bcf         slave_adr,0       ;  
              movf        slave_adr,W       ;  
              call        peredi2c          ; 
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

              movf        adr_i2c,W         ;  I2C
              call        peredi2c          ;   
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c
          
              btfss       flag,3            ;     
              goto        i2c_3
              bcf         flag,3
              movlw       AC1_LH
              goto        i2c_4  
i2c_3         movlw       data_i2c       
i2c_4         movwf       FSR
              decf        FSR,F

              btfss       flag,4            ;  / I2C
              goto        rd_i2c            ;   rd_i2c ()

i2c_2         incf        FSR,F
              movf        INDF,W            ;   
              call        peredi2c          ;   I2C
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

              decfsz      tmp_i2c,F
              goto        i2c_2
              call        stopi2c 
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rd_i2c        call        starti2c          ;  ( )
              bsf         slave_adr,0       ;  
              movf        slave_adr,W       ;  
              call        peredi2c          ; 
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

rd_i2c_2      decfsz      tmp_i2c,F
              goto        rd_i2c_1
              bsf         flag,5
rd_i2c_1      incf        FSR,F
              call        priemi2c          ; 
            
              movwf       INDF
              movlw       .0
              xorwf       tmp_i2c,F
              btfss       STATUS,Z
              goto        rd_i2c_2
              call        stopi2c           ; 
              return

err_i2c       call        stopi2c           ;  ""  I2C 
              return                        ;        I2C

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

starti2c      call        scl_1              ;  scl
              call        pausi2c            ; I2C (5 )
              call        sda_0              ;  0  sda
              call        pausi2c            ; I2C (5 )
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              return                         ;  

stopi2c       call        sda_0              ;  0  sda
              call        pausi2c            ; I2C (5 )
              call        scl_1              ;  scl
stpi2c_1      call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        stpi2c_1           ;
              call        sda_1              ;  sda
              call        pausi2c            ; I2C (5 )
              return                         ;  

sda_1         bsf         STATUS,RP0         ;  sda  
              bsf         sda_io             ;        
              bcf         STATUS,RP0         ;
              return                         ;  

sda_0         bcf         sda                ;  sda  
              bsf         STATUS,RP0         ;
              bcf         sda_io             ;
              bcf         STATUS,RP0         ;
              return                         ;  

scl_1         bsf         STATUS,RP0         ;  scl  
              bsf         scl_io             ;        
              bcf         STATUS,RP0         ;
              return                        ;  

scl_0         bcf         scl                ;  scl  
              bsf         STATUS,RP0         ;
              bcf         scl_io             ;
              bcf         STATUS,RP0         ;
              return                         ;  


peredi2c      movwf       perem              ;    i2c
              movlw       .8                 ;
              movwf       scetbit            ;
prd_i2c_1     btfsc       perem,7            ;
              call        sda_1              ;  sda
              btfss       perem,7            ;
              call        sda_0              ;  0  sda
              call        scl_1              ;  scl
prd_i2c_2     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prd_i2c_2          ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              rlf         perem,F            ;
              decfsz      scetbit,F          ;
              goto        prd_i2c_1          ;
            
              call        sda_1              ;  sda
              call        scl_1              ;  scl
prd_i2c_3     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prd_i2c_3          ;

              movlw       .20                ;  100 
              movwf       scetbit            ;
prd_i2c_4     btfss       sda                ;	
              goto        prd_i2c_5          ;
              decfsz      scetbit,F          ; 
              goto        prd_i2c_4          ;
              bsf         flag,6             ; ,    
prd_i2c_5     call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              return                         ;  


priemi2c      movlw       .8                 ;    i2c
              movwf       scetbit            ;
              call        sda_1              ;  sda
prm_i2c_1     rlf         perem,F            ;
              call        scl_1              ;  scl
prm_i2c_2     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prm_i2c_2          ;
              btfsc       sda                ;
              bsf         perem,0            ;
              btfss       sda                ;
              bcf         perem,0            ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              decfsz      scetbit,F          ;
              goto        prm_i2c_1          ;
 
              btfss       flag,5             ;
              call        sda_0              ;  0  sda

              call        scl_1              ;  scl
prm_i2c_3     call        pausi2c            ; I2C (5 )
              btfss       scl                ;
              goto        prm_i2c_3          ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
              movf        perem,W            ;
              return                         ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;             

pausi2c       nop                            ;  I2C (5 )
              return                         ;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                  
viv_not       movlw       'A'               ;     (--- )
              call        viv_symb          ;  "-" 
              movlw       'A'               ;
              call        viv_symb          ;  "-" 
              movlw       'B'               ;
              call        viv_symb          ;  "-" 
              movlw       'B'               ;
              call        viv_symb          ;  " " 
              return                        ;  
             
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

init_lcd      bcf        res_lcd           ;           
              nop
              nop
              bsf        res_lcd 
              nop
              nop 
                    
                         
              movlw      0x21              ;  , .,   
              call       sendispcom        ;
              movlw      0x13              ;   Bias 1:48
              call       sendispcom        ;
              movlw      0x04              ;   4
              call       sendispcom
              movlw      0xC1              ;  ( Vop) 6,42 (0B8)
              call       sendispcom
              movlw      0x20              ;  
              call       sendispcom  
              movlw      0x0C              ; -   
              call       sendispcom 
              return
              
ust_cur_1     movlw       0x40              ;    Y0
              movwf       y_adr
              call        sendispcom
              goto        ust
ust_cur_2     movlw       0x41              ;    Y1
              movwf       y_adr
              call        sendispcom
              goto        ust
ust_cur_3     movlw       0x42              ;    Y2
              movwf       y_adr
              call        sendispcom
              goto        ust
ust_cur_4     movlw       0x43              ;    Y3
              movwf       y_adr
              call        sendispcom
              goto        ust
ust_cur_5     movlw       0x44              ;    Y4
              movwf       y_adr
              call        sendispcom
              goto        ust
ust_cur_6     movlw       0x45              ;    Y5
              movwf       y_adr
              call        sendispcom
ust           movlw       0x80              ;    X0
              movwf       x_adr
              call        sendispcom
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

clear_lcd     movlw      0x40               ;  
              movwf      y_adr
              call       sendispcom         ;    Y0
              movlw      0x80   
              movwf      x_adr           
              call       sendispcom         ;    X0
              movlw      .6                 ; ,  504
              movwf      Sec1
povt4         movlw      .84
              movwf      Sec
povt3         movlw      .0
              call       sendispdat         ;  0x00  
              decfsz     Sec,F              ;  504 
              goto       povt3              ;  
              decfsz     Sec1,F             
              goto       povt4
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sendispcom    movwf      perem              ;  /  
              bcf        dat_com
              goto       povt1
sendispdat    movwf      perem
              bsf        dat_com
povt1         movlw      .8
              movwf      scetbit
              bcf        cs
povt2         bcf        sclk
              btfsc      perem,7
              bsf        sdata
              btfss      perem,7
              bcf        sdata
              bsf        sclk                                   
              rlf        perem,F
              decfsz     scetbit,F             
              goto       povt2
              bsf        cs
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      
viv_symb      movwf       nomer             ;    
              sublw       .47               ;
              btfss       STATUS,C          ;
              goto        viv_symb_1        ;   47:    viv_symb_1
              movlw       .32               ;  nomer      (ASCII  32)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              goto        viv_s1            ; :   viv_s1
              movlw       .0                ;     (ASCII  32)
              movwf       nomer             ;  .  
              goto        viv_tab4

viv_s1        movlw       .43               ;  nomer     '+' (ASCII  43)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              goto        viv_s2            ; :   viv_s1
              movlw       .1                ;    '+' (ASCII  43)
              movwf       nomer             ;  .  
              goto        viv_tab4           

viv_s2        movlw       .45               ;  nomer     '-' (ASCII  45)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              goto        viv_s3            ; :   viv_s1
              movlw       .2                ;    '-' (ASCII  45)
              movwf       nomer             ;  .  
              goto        viv_tab4

viv_s3        movlw       .46               ;  nomer     '.' (ASCII  46)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              return                        ; :   
              movlw       .3                ;    '.' (ASCII  46)
              movwf       nomer             ;  .  
              goto        viv_tab4

viv_symb_1    movf        nomer,W
              sublw       .57
              btfss       STATUS,C
              goto        viv_symb_2        ;   57:    viv_symb_2
              movlw       .48               ;   47   58:    tab_symb_1
              subwf       nomer,F           ;  48  ASCII  , 
              movlw       .1                ;  
              movwf       tmp_tab           ;   (1)   tmp_tab
              goto        symb_lcd

viv_symb_2    movf        nomer,W
              sublw       .64
              btfsc       STATUS,C
              return                        ;   57   65:   

              movf        nomer,W
              sublw       .78
              btfss       STATUS,C
              goto        viv_symb_3        ;   78:    viv_symb_3
              movlw       .65               ;   64   79:    tab_symb_2
              subwf       nomer,F           ;  65  ASCII  ,  
              movlw       .2                ;  
              movwf       tmp_tab           ;   (2)   tmp_tab
              goto        symb_lcd

viv_symb_3    movf        nomer,W
              sublw       .90
              btfss       STATUS,C
              goto        viv_symb_4        ;   90:    viv_symb_4
              movlw       .79               ;   78   91:    tab_symb_3
              subwf       nomer,F           ;  79  ASCII  ,  
              movlw       .3                ;  
              movwf       tmp_tab           ;   (3)   tmp_tab
              goto        symb_lcd

viv_symb_4    movlw       .176              ;  nomer     176
              xorwf       nomer,W           ;176 - ascii    , 
              btfss       STATUS,Z
              return                        ;  :   
              movlw       .4                ;   176,   , 
              movwf       nomer             ;  .  
viv_tab4      movlw       .4
              movwf       tmp_tab           ;   (4)   tmp_tab

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

symb_lcd      movlw      .17                 ;     18
              movwf      temp
              movf       nomer,W
symb_1        addwf      nomer,F
              decfsz     temp,F
              goto       symb_1
              bcf        flag,0
     
symb_2        movlw      .9 
              movwf      temp               ;    9  

symb_3        movlw       .1                ;    
              xorwf       tmp_tab,W         ;   
              btfss       STATUS,Z
              goto        symb_m1
              call        tab_symb_1
              goto        symb_4
symb_m1       movlw       .2
              xorwf       tmp_tab,W
              btfss       STATUS,Z
              goto        symb_m2
              call        tab_symb_2
              goto        symb_4   
symb_m2       movlw       .3
              xorwf       tmp_tab,W
              btfss       STATUS,Z
              goto        symb_m3
              call        tab_symb_3
              goto        symb_4  
symb_m3       call        tab_symb_4

symb_4        call       sendispdat          ;    
              incf       nomer,F
              incf       x_adr,F
              decfsz     temp,F
              goto       symb_3

              movlw      .0
              call       sendispdat          ;   (0x00)  
              incf       x_adr,F

              btfsc      flag,0
              goto       viv_4
         
              movlw      .10
              subwf      x_adr,F
              incf       y_adr,F
              movf       y_adr,W             ;    Y+1
              call       sendispcom 
              movf       x_adr,W             ;    X-10
              call       sendispcom 
              bsf        flag,0
              goto       symb_2

viv_4         decf       y_adr,F
              movf       y_adr,W          ;    Y-1
              call       sendispcom 
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_1    movlw       high tab1         ;    
              movwf       PCLATH            ; 0-9
              movf        nomer,W           ;
              addlw       low tab1          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  
                                                  
tab1          dt 0xfc,0xfe,0x03,0x83,0xc3,0x63,0x33,0xfe,0xfc; 
              dt 0x0f,0x1f,0x33,0x31,0x30,0x30,0x30,0x1f,0x0f; '0'    ASCII  48
              dt 0x00,0x10,0x18,0x1c,0xfe,0xff,0x00,0x00,0x00; 
              dt 0x00,0x30,0x30,0x30,0x3f,0x3f,0x30,0x30,0x30; '1'
              dt 0x0c,0x0e,0x03,0x03,0x03,0x83,0xc3,0x7e,0x3c; 
              dt 0x30,0x38,0x3c,0x36,0x33,0x31,0x30,0x30,0x30; '2'
              dt 0x0c,0x0e,0x03,0xc3,0xc3,0xc3,0xc3,0xfe,0x3c; 
              dt 0x0c,0x1c,0x30,0x30,0x30,0x30,0x30,0x1f,0x0f; '3'
              dt 0xc0,0xe0,0xb0,0x98,0x8c,0x86,0x83,0xff,0xff; 
              dt 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x3f,0x3f; '4'
              dt 0x3f,0x7f,0x63,0x63,0x63,0x63,0x63,0xe3,0xc3; 
              dt 0x1c,0x3c,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '5'
              dt 0xfe,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xc7,0x86; 
              dt 0x1f,0x3f,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '6'
              dt 0x00,0x03,0x03,0x03,0x03,0x83,0xc3,0x7f,0x3f; 
              dt 0x00,0x00,0x00,0x3e,0x3f,0x01,0x00,0x00,0x00; '7'
              dt 0xbe,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xff,0xbe; 
              dt 0x1f,0x3f,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '8'
              dt 0x7e,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xff,0xfe; 
              dt 0x18,0x38,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '9'   ASCII  57

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_2    movlw       high tab2         ;    
              movwf       PCLATH            ;  A-N
              movf        nomer,W           ;
              addlw       low tab2          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab2          dt 0xfc,0xfe,0xc3,0xc3,0xc3,0xc3,0xc3,0xfe,0xfc; 
              dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x3f,0x3f; 'A'    ASCII  65
              dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0x3c,0x3c; 
              dt 0x3f,0x3f,0x30,0x30,0x30,0x30,0x30,0x0f,0x0f; 'B'
              dt 0xfc,0xfc,0x03,0x03,0x03,0x03,0x03,0x0c,0x0c; 
              dt 0x0f,0x0f,0x30,0x30,0x30,0x30,0x30,0x0c,0x0c; 'C'
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x00,0x00,0x3F,0x3F,0x01,0x01,0x01,0x00 ; 'D'
              dt 0x00,0x00,0xC0,0xC0,0x40,0x40,0xC0,0xC0,0x00  ; 
              dt 0x00,0x00,0x3F,0x3F,0x00,0x00,0x3F,0x3F,0x00   ; 'E'
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x00,0x3E,0x3F,0x09,0x09,0x3F,0x3E,0x00   ; 'F'
              dt 0xfc,0xfe,0x03,0x03,0x83,0x83,0x83,0x8e,0x8c; 
              ;dt 0x0f,0x1f,0x30,0x30,0x31,0x31,0x31,0x1f,0x0f; 'G'
             ; dt 0xff,0xff,0xc0,0xc0,0xc0,0xc0,0xc0,0xff,0xff; 
             ; dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x3f,0x3f; 'H'
             ; dt 0x00,0x03,0x03,0xff,0xff,0x03,0x03,0x00,0x00; 
             ; dt 0x00,0x30,0x30,0x3f,0x3f,0x30,0x30,0x00,0x00; 'I'
             ; dt 0x00,0x00,0x00,0x03,0x03,0xff,0xff,0x03,0x03; 
              ;dt 0x0c,0x1c,0x30,0x30,0x30,0x1f,0x0f,0x00,0x00; 'J'
              ;dt 0xff,0xff,0xc0,0xe0,0x30,0x18,0x0c,0x07,0x03; 
              ;dt 0x3f,0x3f,0x00,0x01,0x03,0x06,0x0c,0x38,0x30; 'K'
              ;dt 0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              ;dt 0x3f,0x3f,0x30,0x30,0x30,0x30,0x30,0x30,0x30; 'L'
              ;dt 0xff,0xff,0x06,0x0c,0x18,0x0c,0x06,0xff,0xff; 
             ; dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x3f,0x3f; 'M'
              ;dt 0xff,0xff,0x30,0x60,0xc0,0x80,0x00,0xff,0xff; 
              ;dt 0x3f,0x3f,0x00,0x00,0x00,0x01,0x03,0x3f,0x3f; 'N'   ASCII  78

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_3    movlw       high tab3         ;    
              movwf       PCLATH            ;  O-Z
              movf        nomer,W           ;
              addlw       low tab3          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab3      dt 0x00, 0x3C,0x7E,0xC3,0xC3,0xC3,0xC3,0x7E,0x3C ; gradus
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 'O'    ASCII  79
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00    ; 
              dt 0x00,0x00,0x3F,0x3F,0x02,0x0C,0x02,0x3F,0x3F   ; 'P'
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt  0x00,0x00,0x3F,0x3F,0x02,0x0C,0x02,0x3F,0x3F ; 'Q'
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x30,0x30,0x00,0x3F,0x3F,0x09,0x09,0x06 ; 'R'
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x30,0x30,0x00,0x1E,0x3F,0x21,0x21,0x12  ; 'S'
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x01,0x01,0x3F,0x3F,0x01,0x01,0x30,0x30  ; 'T'
              ;dt 0xff,0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff; 
              ;dt 0x0f,0x1f,0x30,0x30,0x30,0x30,0x30,0x1f,0x0f; 'U'
              ;dt 0xff,0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff; 
              ;dt 0x03,0x07,0x0c,0x18,0x30,0x18,0x0c,0x07,0x03; 'V'
              ;dt 0xff,0xff,0x00,0x00,0xff,0x00,0x00,0xff,0xff; 
              ;dt 0x0f,0x1f,0x30,0x30,0x1f,0x30,0x30,0x1f,0x0f; 'W'
              ;dt 0x07,0x0f,0x18,0xf0,0xe0,0xf0,0x18,0x0f,0x07; 
              ;dt 0x38,0x3c,0x06,0x03,0x01,0x03,0x06,0x3c,0x38; 'X'
              ;dt 0x3f,0x7f,0xc0,0xc0,0xc0,0xc0,0xc0,0x7f,0x3f; 
              ;dt 0x00,0x00,0x00,0x3f,0x3f,0x3f,0x00,0x00,0x00; 'Y'
              ;dt 0x03,0x03,0x03,0x83,0xc3,0x63,0x33,0x1f,0x0f; 
              ;dt 0x3c,0x3e,0x33,0x31,0x30,0x30,0x30,0x30,0x30; 'Z'    ASCII  90

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_4    movlw       high tab4         ;    
              movwf       PCLATH            ;: , , ,  
              movf        nomer,W           ; , 
              addlw       low tab4          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab4          dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; ()  ASCII  32
              dt 0xc0,0xc0,0xc0,0xf8,0xf8,0xc0,0xc0,0xc0,0x00; 
              dt 0x00,0x00,0x00,0x07,0x07,0x00,0x00,0x00,0x00; '+'  ASCII  43
              dt 0x00,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0x00; 
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; '-'  ASCII  45
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x00,0x00,0x3c,0x3c,0x3c,0x00,0x00,0x00; '.'  ASCII  46
              dt 0x00,0x1c,0x3e,0x63,0x63,0x63,0x3e,0x1c,0x00; 
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; (  , ) ASCII  176
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
paus          movlw       .7                ;  5,3 
              movwf       Sec1              ;
p_l2          movlw       .255              ;
              movwf       Sec               ;
p_l1          decfsz      Sec,F             ;
              goto        p_l1              ;
              decfsz      Sec1,F            ;
              goto        p_l2              ;
              return

paus1s        movlw       .5                ;  1 
              movwf       Sec2
ps_3          movlw       .255              ;
              movwf       Sec1              ;
ps_2          movlw       .255              ;
              movwf       Sec               ;
ps_1          decfsz      Sec,F             ;
              goto        ps_1              ;
              decfsz      Sec1,F            ;
              goto        ps_2              ;
              decfsz      Sec2,F            ;
              goto        ps_3 
              return                        ;  

              end                           ;  


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
